# MittelmannBndryCntrlDiriBase3Dsin Class Reference

Base class for boundary control problems with Dirichlet boundary conditions, as formulated by Hans Mittelmann as Examples 1-4 in Optimization Techniques for Solving Elliptic Control Problems with Control and State Constraints. More...

`#include <MittelmannBndryCntrlDiri3Dsin.hpp>`

Inheritance diagram for MittelmannBndryCntrlDiriBase3Dsin:
[legend]

List of all members.

## Public Member Functions
| MittelmannBndryCntrlDiriBase3Dsin ()
| Constructor.
virtual | ~MittelmannBndryCntrlDiriBase3Dsin ()
| Default destructor.
virtual bool | get_scaling_parameters (Number &obj_scaling, bool &use_x_scaling, Index n, Number *x_scaling, bool &use_g_scaling, Index m, Number *g_scaling)
| Method for returning scaling parameters.
Overloaded from TNLP
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp.
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem.
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm.
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value.
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective.
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals.
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).
Solution Methods
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_valu, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called after the optimization, and could write an output file with the optimal profiles.
## Protected Member Functions
void | SetBaseParameters (Index N, Number alpha, Number lb_y, Number ub_y, Number lb_u, Number ub_u, Number d_const)
| Method for setting the internal parameters that define the problem.
Functions that defines a particular instance.
virtual Number | y_d_cont (Number x1, Number x2, Number x3) const =0
| Target profile function for y.
## Private Member Functions
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| MittelmannBndryCntrlDiriBase3Dsin (const MittelmannBndryCntrlDiriBase3Dsin &)
MittelmannBndryCntrlDiriBase3Dsin & | operator= (const MittelmannBndryCntrlDiriBase3Dsin &)
| Overloaded Equals Operator.
Auxilliary methods
Index | y_index (Index i, Index j, Index k) const
| Translation of mesh point indices to NLP variable indices for y(x_ijk).
Index | pde_index (Index i, Index j, Index k) const
| Translation of interior mesh point indices to the corresponding PDE constraint number.
Number | x1_grid (Index i) const
| Compute the grid coordinate for given index in x1 direction.
Number | x2_grid (Index i) const
| Compute the grid coordinate for given index in x2 direction.
Number | x3_grid (Index i) const
| Compute the grid coordinate for given index in x3 direction.
## Private Attributes
Problem specification
Index | N_
| Number of mesh points in one dimension (excluding boundary).
Number | h_
| Step size.
Number | hh_
| h_ squaredd
Number | lb_y_
| overall lower bound on y
Number | ub_y_
| overall upper bound on y
Number | lb_u_
| overall lower bound on u
Number | ub_u_
| overall upper bound on u
Number | d_const_
| Constant value of d appearing in elliptical equation.
Number | alpha_
| Weighting parameter for the control target deviation functional in the objective.
Number * | y_d_
| Array for the target profile for y.

## Detailed Description

Base class for boundary control problems with Dirichlet boundary conditions, as formulated by Hans Mittelmann as Examples 1-4 in Optimization Techniques for Solving Elliptic Control Problems with Control and State Constraints.

Part 2: Boundary Control

Here, the control variables are identical to the values of y on the boundary, and therefore we don't need any explicit optimization variables for u.

Definition at line 53 of file MittelmannBndryCntrlDiri3Dsin.hpp.

## Constructor & Destructor Documentation

MittelmannBndryCntrlDiriBase3Dsin::MittelmannBndryCntrlDiriBase3Dsin | ( |  | ) |

Constructor.

virtual MittelmannBndryCntrlDiriBase3Dsin::~MittelmannBndryCntrlDiriBase3Dsin | ( |  | ) | `[virtual]`

Default destructor.

MittelmannBndryCntrlDiriBase3Dsin::MittelmannBndryCntrlDiriBase3Dsin | ( | const MittelmannBndryCntrlDiriBase3Dsin & |  | ) | `[private]`

## Member Function Documentation

virtual bool MittelmannBndryCntrlDiriBase3Dsin::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style |
| ) |  |  | `[virtual]`

Method to return some info about the nlp.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u |
| ) |  |  | `[virtual]`

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda |
| ) |  |  | `[virtual]`

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value |
| ) |  |  | `[virtual]`

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f |
| ) |  |  | `[virtual]`

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g |
| ) |  |  | `[virtual]`

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).

Reimplemented from Ipopt::TNLP.

virtual bool MittelmannBndryCntrlDiriBase3Dsin::get_scaling_parameters | ( | Number & | obj_scaling,
|  | bool & | use_x_scaling,
|  | Index | n,
|  | Number * | x_scaling,
|  | bool & | use_g_scaling,
|  | Index | m,
|  | Number * | g_scaling |
| ) |  |  | `[virtual]`

Method for returning scaling parameters.

Reimplemented from Ipopt::TNLP.

virtual void MittelmannBndryCntrlDiriBase3Dsin::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_valu,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

This method is called after the optimization, and could write an output file with the optimal profiles.

Implements Ipopt::TNLP.

void MittelmannBndryCntrlDiriBase3Dsin::SetBaseParameters | ( | Index | N,
|  | Number | alpha,
|  | Number | lb_y,
|  | Number | ub_y,
|  | Number | lb_u,
|  | Number | ub_u,
|  | Number | d_const |
| ) |  |  | `[protected]`

Method for setting the internal parameters that define the problem.

It must be called by the child class in its implementation of InitializeParameters.

virtual Number MittelmannBndryCntrlDiriBase3Dsin::y_d_cont | ( | Number | x1,
|  | Number | x2,
|  | Number | x3 |
| ) |  |  | const`[protected, pure virtual]`

Target profile function for y.

Implemented in MittelmannBndryCntrlDiri3Dsin.

MittelmannBndryCntrlDiriBase3Dsin& MittelmannBndryCntrlDiriBase3Dsin::operator= | ( | const MittelmannBndryCntrlDiriBase3Dsin & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::TNLP.

Reimplemented in MittelmannBndryCntrlDiri3Dsin.

Index MittelmannBndryCntrlDiriBase3Dsin::y_index | ( | Index | i,
|  | Index | j,
|  | Index | k |
| ) |  |  | const`[inline, private]`

Translation of mesh point indices to NLP variable indices for y(x_ijk).

Definition at line 184 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Index MittelmannBndryCntrlDiriBase3Dsin::pde_index | ( | Index | i,
|  | Index | j,
|  | Index | k |
| ) |  |  | const`[inline, private]`

Translation of interior mesh point indices to the corresponding PDE constraint number.

Definition at line 190 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::x1_grid | ( | Index | i | ) | const`[inline, private]`

Compute the grid coordinate for given index in x1 direction.

Definition at line 195 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::x2_grid | ( | Index | i | ) | const`[inline, private]`

Compute the grid coordinate for given index in x2 direction.

Definition at line 200 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::x3_grid | ( | Index | i | ) | const`[inline, private]`

Compute the grid coordinate for given index in x3 direction.

Definition at line 205 of file MittelmannBndryCntrlDiri3Dsin.hpp.

## Member Data Documentation

Index MittelmannBndryCntrlDiriBase3Dsin::N_`[private]`

Number of mesh points in one dimension (excluding boundary).

Definition at line 158 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::h_`[private]`

Step size.

Definition at line 160 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::hh_`[private]`

h_ squaredd

Definition at line 162 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::lb_y_`[private]`

overall lower bound on y

Definition at line 164 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::ub_y_`[private]`

overall upper bound on y

Definition at line 166 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::lb_u_`[private]`

overall lower bound on u

Definition at line 168 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::ub_u_`[private]`

overall upper bound on u

Definition at line 170 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::d_const_`[private]`

Constant value of d appearing in elliptical equation.

Definition at line 172 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number MittelmannBndryCntrlDiriBase3Dsin::alpha_`[private]`

Weighting parameter for the control target deviation functional in the objective.

Definition at line 175 of file MittelmannBndryCntrlDiri3Dsin.hpp.

Number* MittelmannBndryCntrlDiriBase3Dsin::y_d_`[private]`

Array for the target profile for y.

Definition at line 177 of file MittelmannBndryCntrlDiri3Dsin.hpp.

The documentation for this class was generated from the following file:

- examples/ScalableProblems/MittelmannBndryCntrlDiri3Dsin.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines